/////*****XD-Cube main script file*****/////

/////Video Mode/////
var video_screen = 1;
var video_mode = 8;
var video_depth = 32;

/////Includes/////
include <variables.wdl>;
include <strings.wdl>;
include <panels.wdl>;
include <functions.wdl>;
include <actions.wdl>;

//Button control
on_esc = null;
on_f1 = null;
on_f2 = null;
on_f3 = null;
on_f5 = null;
on_f6 = null;
on_f7 = null;
on_f8 = null;

/////Main function/////

function main()
{
	vec_set(sky_color,(vector(0,0,0)));
	camera.clip_near = 5;
	filehandle = file_open_read("configuration.txt");
	resolution = file_var_read(filehandle);
	sound_volume = file_var_read(filehandle);
	music_volume = file_var_read(filehandle);
	file_close(filehandle);
	freeze_mode = 1;
	menu = 1;
	wait(2);
	if(resolution < 1.5)
	{
		video_switch(6,0,0);
		black_pan.bmap = black640_jpg;
		a6logo_pan.bmap = a6logo640_jpg;
		splashmap_pan.bmap = splash640_jpg; 
	}
	if(resolution >= 1.5 && resolution < 2.5)
	{
		video_switch(7,0,0);
		black_pan.bmap = black800_jpg;
		a6logo_pan.bmap = a6logo800_jpg;
		splashmap_pan.bmap = splash800_jpg;
	}
	if(resolution >= 2.5)
	{
		video_switch(8,0,0);
		black_pan.bmap = black_jpg;
		a6logo_pan.bmap = a6logo_jpg;
		splashmap_pan.bmap = splash_jpg;
		black_pan.bmap = black_jpg;
	}
	a6logo_pan.visible = on;
	sleep(4);
	while(a6logo_pan.alpha > 0)
	{
		a6logo_pan.alpha -= 4 * Time;
		wait(1);
	}
	a6logo_pan.visible = off;
	splashmap_pan.visible = on;
	while(splashmap_pan.alpha < 100)
	{
		splashmap_pan.alpha += 4 * Time;
		wait(1);
	}
	black_pan.visible = on;
	level_load(level001_wmb);
	wait(3);
	sleep(2);
	while(splashmap_pan.alpha > 0)
	{
		splashmap_pan.alpha -= 4 * Time;
		wait(1);
	}
	splashmap_pan.visible = off;
	bmap_purge(a6logo_jpg);
	bmap_purge(splash_jpg);
	freeze_mode = 0;
	black_pan.visible = off;
	// for testing purposes:
	//	mode_blockattack = 1;
	//	level_number = 32;
	//	level004 = 1;
	//	world = 1;
	//	cubes_shot = 770;
	//	gun_ent.visible = on;
	//	score_pan.visible = on;
	//	guntable_pan.visible = on;
	//	guntable_mask_pan.visible = on;
	// ends here... un comment menu = 1; line...
	mouse_map = mouse_tga;
	if(resolution < 1.5)
	{
		black_pan.size_x = 640; 
		black_pan.size_y = 480; 
		menu_bg2_pan.bmap = menu_bg2_640_jpg;
		menu_bg2_pan.size_x = 640;
		menu_bg2_pan.size_y = 480;
		menu_bg1_pan.bmap = menu_bg1_640_jpg;
		menu_bg1_pan.size_x = 640;
		menu_bg1_pan.size_y = 480;
		menu_but_pan.pos_x = 140;
		menu_but_pan.pos_y = 40;
		level_but_pan.scale_x = 0.625;
		level_but_pan.scale_y = 0.625;
		options_pan.pos_x = 170;
		options_pan.pos_y = 140;
		return_pan.scale_x = 0.625;
		return_pan.scale_y = 0.625;
		return_pan.pos_y = 0;
		returntomenu_pan.pos_x = 490;
		returntomenu_pan.pos_y = 418;
		guntable_pan.scale_x = 0.78125;
		guntable_pan.scale_y = 0.78125;
		guntable_pan.pos_y = 265;
		guntable_mask_pan.scale_x = 0.78125;
		guntable_mask_pan.scale_y = 0.78125;
		guntable_mask_pan.pos_y = 263;
		ready_pan.bmap = ready_640_jpg;
		ready_pan.size_x = 640;
		ready_pan.size_y = 56;
		ready_pan.pos_y = 160;
		go_pan.bmap = go_640_jpg;
		go_pan.size_x = 640;
		go_pan.size_y = 56;
		go_pan.pos_y = 160;
		game_over_pan.bmap = game_over_640_jpg;
		game_over_pan.size_x = 640;
		game_over_pan.size_y = 63;
		game_over_pan.pos_y = 160;
		worldclear_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 150;
		OKbutton_pan.pos_y = 115;
		OKbutton2_pan.pos_x = 150;
		OKbutton2_pan.pos_y = 115;
		instructions_pan.bmap = instructions_640_jpg;
		instructions_pan.size_x = 640;
		instructions_pan.size_y = 480;
		instructions_pan.pos_x = 0;
		instructions_pan.pos_y = 0;
		compcongmes_pan.pos_x = 0;
		compcongmes_pan.pos_y = 0;
		danke_pan.pos_x = 0;
		danke_pan.pos_y = 0;
		1highscore_pan.pos_x = 640/8;
		1highscore_pan.pos_y = 480/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 480/2;
		ingamemenu_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(6,0,0);
	}
	if(resolution >= 1.5 && resolution < 2.5)
	{
		black_pan.size_x = 800; 
		black_pan.size_y = 600; 
		menu_bg2_pan.bmap = menu_bg2_800_jpg;
		menu_bg2_pan.size_x = 800;
		menu_bg2_pan.size_y = 600;
		menu_bg1_pan.bmap = menu_bg1_800_jpg;
		menu_bg1_pan.size_x = 800;
		menu_bg1_pan.size_y = 600;
		menu_but_pan.pos_x = 200;
		menu_but_pan.pos_y = 100;
		level_but_pan.scale_x = 0.78125;
		level_but_pan.scale_y = 0.78125;
		options_pan.pos_x = 250;
		options_pan.pos_y = 200;
		return_pan.scale_x = 1;
		return_pan.scale_y = 1;
		return_pan.pos_y = -168;
		returntomenu_pan.pos_x = 650;
		returntomenu_pan.pos_y = 538;
		guntable_pan.scale_x = 1;
		guntable_pan.scale_y = 1;
		guntable_pan.pos_y = 330;
		guntable_mask_pan.scale_x = 1;
		guntable_mask_pan.scale_y = 1;
		guntable_mask_pan.pos_y = 328;
		ready_pan.bmap = ready_800_jpg;
		ready_pan.size_x = 800;
		ready_pan.size_y = 70;
		ready_pan.pos_y = 200;
		go_pan.bmap = go_800_jpg;
		go_pan.size_x = 800;
		go_pan.size_y = 70;
		go_pan.pos_y = 200;
		game_over_pan.bmap = game_over_800_jpg;
		game_over_pan.size_x = 800;
		game_over_pan.size_y = 78;
		game_over_pan.pos_y = 200;
		worldclear_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 230;
		OKbutton_pan.pos_y = 160;
		OKbutton2_pan.pos_x = 230;
		OKbutton2_pan.pos_y = 160;
		instructions_pan.bmap = instructions_800_jpg;
		instructions_pan.size_x = 800;
		instructions_pan.size_y = 600;
		instructions_pan.pos_x = 0;
		instructions_pan.pos_y = 0;
		danke_pan.pos_x = 80;
		danke_pan.pos_y = 60;
		compcongmes_pan.pos_x = 80;
		compcongmes_pan.pos_y = 60;
		1highscore_pan.pos_x = 800/8;
		1highscore_pan.pos_y = 600/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 600/2;
		ingamemenu_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(7,0,0);
	}
	if(resolution >= 2.5)
	{
		black_pan.size_x = 1024; 
		black_pan.size_y = 768; 
		menu_bg2_pan.bmap = menu_bg2_jpg;
		menu_bg2_pan.size_x = 1024;
		menu_bg2_pan.size_y = 768;
		menu_bg1_pan.bmap = menu_bg1_jpg;
		menu_bg1_pan.size_x = 1024;
		menu_bg1_pan.size_y = 768;
		menu_but_pan.pos_x = 312;
		menu_but_pan.pos_y = 184;
		level_but_pan.scale_x = 1;
		level_but_pan.scale_y = 1;
		options_pan.pos_x = 362;
		options_pan.pos_y = 284;
		return_pan.scale_x = 1;
		return_pan.scale_y = 1;
		return_pan.pos_y = 0;
		returntomenu_pan.pos_x = 874;
		returntomenu_pan.pos_y = 706;
		guntable_pan.scale_x = 1;
		guntable_pan.scale_y = 1;
		guntable_pan.pos_y = 500;
		guntable_mask_pan.scale_x = 1;
		guntable_mask_pan.scale_y = 1;
		guntable_mask_pan.pos_y = 498;
		ready_pan.bmap = ready_jpg;
		ready_pan.size_x = 1024;
		ready_pan.size_y = 90;
		ready_pan.pos_y = 250;
		go_pan.bmap = go_jpg;
		go_pan.size_x = 1024;
		go_pan.size_y = 90;
		go_pan.pos_y = 250;
		game_over_pan.bmap = game_over_jpg;
		game_over_pan.size_x = 1024;
		game_over_pan.size_y = 100;
		game_over_pan.pos_y = 250;
		worldclear_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 342;
		OKbutton_pan.pos_y = 200;
		OKbutton2_pan.pos_x = 342;
		OKbutton2_pan.pos_y = 200;
		instructions_pan.bmap = instructions_800_jpg;
		instructions_pan.size_x = 800;
		instructions_pan.size_y = 600;
		instructions_pan.pos_x = 112;
		instructions_pan.pos_y = 84;
		danke_pan.pos_x = 192;
		danke_pan.pos_y = 144;
		compcongmes_pan.pos_x = 192;
		compcongmes_pan.pos_y = 144;
		1highscore_pan.pos_x = 1024/8;
		1highscore_pan.pos_y = 768/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 768/2;
		ingamemenu_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(8,0,0);
	}	
	temp_var2=resolution;
	while(1)
	{
		if(menu == 1)
		{
			If(key_esc == 1)
			{
				exit;
			}
			if(mouse_mode == 2)
			{
				mouse_pos.x = pointer.x;
				mouse_pos.y = pointer.y;
			}
			if(show_menu == 0)
			{
				game_over_var = 0;	//allow the music to be played in the game levels
				if(pause == 0)
				{
					pause = 1;
				}
				if(black_pan.visible == off)
				{
					black_pan.visible = on;
				}
				if(name_set == 0)
				{
					instructions_pan.transparent = on;
					instructions_pan.alpha = 0;
					instructions_pan.visible = on;
					while(instructions_pan.alpha < 100)
					{
						instructions_pan.alpha +=5*time;
						wait(1);
					}
					if(namespace_pan.visible == off)
					{
						namespace_pan.visible = on;
						namespace_txt.visible = on;
					}
					inkey(playerinput);
					inkey_active = on;
					if(result == 13)
					{
						if(str_len(playerinput) > 2)
						{
							str_cpy(playername,playerinput);
						}						
						else
						{
							str_cpy(playername,empty);
						}
						name_set = 1;
						namespace_pan.visible = off;
						namespace_txt.visible = off;
						instructions_pan.visible = off;
					}
				}			
				if(name_set == 1)
				{
					inkey_active = off;
					sleep(0.5);
					menu_bg2_pan.alpha = 0;
					menu_bg2_pan.transparent = on;
					menu_bg2_pan.visible = on;
					while(menu_bg2_pan.alpha < 100)
					{
						menu_bg2_pan.alpha +=5*time;
						wait(1);
					}
					sleep(1.25);
					menu_bg1_pan.alpha = 0;
					menu_bg1_pan.transparent = on;
					menu_bg1_pan.visible = on;
					while(menu_bg1_pan.alpha < 100)
					{
						menu_bg1_pan.alpha +=5*time;
						wait(1);
					}
					menu_but_pan.visible = on;
					filehandle = file_open_read("hs1.txt");
					1hscore1 = file_var_read(filehandle);
					1hscore2 = file_var_read(filehandle);
					1hscore3 = file_var_read(filehandle);
					1hscore4 = file_var_read(filehandle);
					1hscore5 = file_var_read(filehandle);
					file_str_read(filehandle,1hscorepl1);
					file_str_read(filehandle,1hscorepl2);
					file_str_read(filehandle,1hscorepl3);
					file_str_read(filehandle,1hscorepl4);
					file_str_read(filehandle,1hscorepl5);
					file_close(filehandle);						
					1highscore_pan.visible = on;
					1highscore_txt.visible = on;
					mouse_mode = 2;
					show_menu = 1;
				}
			}
		}
		//for developers: fasten the blocks
		//		if(key_f == 1)
		//		{
			//			time_factor = 10;
		//		}
		//		else
		//		{
			//			time_factor = 1;
		//		}
		//screenshot mode here XD
		//		if(key_x == 1)
		//		{
			//			freeze_mode = 1;
		//		}
		//		else
		//		{
			//			freeze_mode = 0;
		//		}
		if(mode_blockattack == 1)
		{
			if(mouse_mode == 2)
			{
				mouse_pos.x = pointer.x;
				mouse_pos.y = pointer.y;
			}
			if(cubes_shot == 25 && level_number == 1)
			{
				show_congrats();
			}
			if(cubes_shot == 55  && level_number == 2)
			{
				show_congrats();
			}
			if(cubes_shot == 85  && level_number == 3)
			{
				show_congrats();
			}
			if(cubes_shot == 110  && level_number == 4)
			{
				show_congrats();
			}
			if(cubes_shot == 150  && level_number == 5)
			{
				show_congrats();
			}
			if(cubes_shot == 200  && level_number == 6)
			{
				show_congrats();
			}
			if(cubes_shot == 260  && level_number == 7)
			{
				show_congrats();
			}
			if(cubes_shot == 330  && level_number == 8)
			{
				if(pause == 0)
				{
					pause = 1;
					level_clear = 1;
					congratulations2_pan.pos_x = screen_size.x/2 - bmap_width(congratulations2_tga)/2;
					congratulations2_pan.pos_y = screen_size.y/2 - bmap_height(congratulations2_tga)/2;
					congratulations2_pan.alpha = 100;
					congratulations2_pan.transparent = on;
					congratulations2_pan.visible = on;
					sleep(2);
					while(congratulations2_pan.alpha > 0)
					{
						congratulations2_pan.alpha -= 4 * Time;
						wait(1);
					}:
					congratulations2_pan.visible = off;
					worldclear_pan.pos_x = screen_size.x/2 - bmap_width(ingamemenu_jpg)/2;
					worldclear_pan.pos_y = screen_size.y/2 - bmap_height(ingamemenu_jpg)/2;
					worldclear_pan.visible = on;
					if(show_mouse == 0)
					{
						mouse_mode = 2;
						show_mouse = 1;
					}
				}
			}
			if(cubes_shot == 40  && level_number == 9)
			{
				show_congrats();
			}
			if(cubes_shot == 90  && level_number == 10)
			{
				show_congrats();
			}
			if(cubes_shot == 160  && level_number == 11)
			{
				show_congrats();
			}
			if(cubes_shot == 240  && level_number == 12)
			{
				show_congrats();
			}
			if(cubes_shot == 340  && level_number == 13)
			{
				show_congrats();
			}
			if(cubes_shot == 440  && level_number == 14)
			{
				show_congrats();
			}
			if(cubes_shot == 530  && level_number == 15)
			{
				show_congrats();
			}
			if(cubes_shot == 630  && level_number == 16)
			{
				if(pause == 0)
				{
					pause = 1;
					level_clear = 1;
					congratulations2_pan.pos_x = screen_size.x/2 - bmap_width(congratulations2_tga)/2;
					congratulations2_pan.pos_y = screen_size.y/2 - bmap_height(congratulations2_tga)/2;
					congratulations2_pan.alpha = 100;
					congratulations2_pan.transparent = on;
					congratulations2_pan.visible = on;
					sleep(2);
					while(congratulations2_pan.alpha > 0)
					{
						congratulations2_pan.alpha -= 4 * Time;
						wait(1);
					}:
					congratulations2_pan.visible = off;
					worldclear_pan.pos_x = screen_size.x/2 - bmap_width(ingamemenu_jpg)/2;
					worldclear_pan.pos_y = screen_size.y/2 - bmap_height(ingamemenu_jpg)/2;
					worldclear_pan.visible = on;
					if(show_mouse == 0)
					{
						mouse_mode = 2;
						show_mouse = 1;
					}
				}
			}
			if(cubes_shot == 70  && level_number == 17)
			{
				show_congrats();
			}
			if(cubes_shot == 150  && level_number == 18)
			{
				show_congrats();
			}
			if(cubes_shot == 240  && level_number == 19)
			{
				show_congrats();
			}
			if(cubes_shot == 340  && level_number == 20)
			{
				show_congrats();
			}
			if(cubes_shot == 450  && level_number == 21)
			{
				show_congrats();
			}
			if(cubes_shot == 550  && level_number == 22)
			{
				show_congrats();
			}
			if(cubes_shot == 660  && level_number == 23)
			{
				show_congrats();
			}
			if(cubes_shot == 770  && level_number == 24)
			{
				if(pause == 0)
				{
					pause = 1;
					level_clear = 1;
					congratulations2_pan.pos_x = screen_size.x/2 - bmap_width(congratulations2_tga)/2;
					congratulations2_pan.pos_y = screen_size.y/2 - bmap_height(congratulations2_tga)/2;
					congratulations2_pan.alpha = 100;
					congratulations2_pan.transparent = on;
					congratulations2_pan.visible = on;
					sleep(2);
					while(congratulations2_pan.alpha > 0)
					{
						congratulations2_pan.alpha -= 4 * Time;
						wait(1);
					}:
					congratulations2_pan.visible = off;
					worldclear_pan.pos_x = screen_size.x/2 - bmap_width(ingamemenu_jpg)/2;
					worldclear_pan.pos_y = screen_size.y/2 - bmap_height(ingamemenu_jpg)/2;
					worldclear_pan.visible = on;
					if(show_mouse == 0)
					{
						mouse_mode = 2;
						show_mouse = 1;
					}
				}
			}
			if(cubes_shot == 70  && level_number == 25)
			{
				show_congrats();
			}
			if(cubes_shot == 140  && level_number == 26)
			{
				show_congrats();
			}
			if(cubes_shot == 220  && level_number == 27)
			{
				show_congrats();
			}
			if(cubes_shot == 310  && level_number == 28)
			{
				show_congrats();
			}
			if(cubes_shot == 420  && level_number == 29)
			{
				show_congrats();
			}
			if(cubes_shot == 530  && level_number == 30)
			{
				show_congrats();
			}
			if(cubes_shot == 650  && level_number == 31)
			{
				show_congrats();
			}
			if(cubes_shot == 800  && level_number == 32)
			{
				show_congratsend();
			}
			//game over control starts here
			if(level_number == 1 && cube_amount >= 24)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 2 && cube_amount >= 24)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 3 && cube_amount >= 24)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 4 && cube_amount >= 24)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 5 && cube_amount >= 30)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 6 && cube_amount >= 35)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 7 && cube_amount >= 41)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 8 && cube_amount >= 46)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 9 && cube_amount >= 36)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 10 && cube_amount >= 36)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 11 && cube_amount >= 40)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 12 && cube_amount >= 45)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 13 && cube_amount >= 45)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 14 && cube_amount >= 47)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 15 && cube_amount >= 35)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 16 && cube_amount >= 45)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 17 && cube_amount >= 35)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 18 && cube_amount >= 43)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 19 && cube_amount >= 43)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 20 && cube_amount >= 43)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 21 && cube_amount >= 48)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 22 && cube_amount >= 48)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 23 && cube_amount >= 48)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 24 && cube_amount >= 48)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 25 && cube_amount >= 55)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 26 && cube_amount >= 55)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 27 && cube_amount >= 55)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 28 && cube_amount >= 55)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 29 && cube_amount >= 40)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 30 && cube_amount >= 50)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 31 && cube_amount >= 50)
			{
				pause = 1;
				game_over();
			}
			if(level_number == 32 && cube_amount >= 45)
			{
				pause = 1;
				game_over();
			}
		}
		wait(1);
	}
}

function esc_func()
{
	if(menu == 1)
	{
		exit;
	}
	else 
	{
		if(level_clear == 0)
		{
			ingamemenu_pan.pos_x = screen_size.x/2 - bmap_width(ingamemenu_jpg)/2;
			ingamemenu_pan.pos_y = screen_size.y/2 - bmap_height(ingamemenu_jpg)/2;
			ingamemenu_pan.visible = on;
			mouse_mode = 2;
			freeze_mode = 1;
		}
	}
}

on_esc = esc_func();