/////This file contains all fo the functions (and some necessary entities)/////
/////functions.wdl/////

//Gun entity//
entity gun_ent
{
	type = <gun001.mdl>;
	layer = 2;
	//	flags = visible;
	albedo = 100;
	view = camera;
	x = -13;
	z = 1;
	tilt = 7;
}

//Camera function//
function camera_function()
{
	my.invisible = on;
	camera.diameter = 0;
	camera.genius = null;
	
	//camera position calculation
	orbit_camera_dist = cos(orbit_camera_tilt) * camera_dist;
	camera.x = player.x - cos(orbit_camera_pan) * orbit_camera_dist;
	camera.y = player.y - sin(orbit_camera_pan) * orbit_camera_dist;
	camera.z = player.z + sin(orbit_camera_tilt) * camera_dist;
	
	//camera pan, tilt, and roll settings
	camera.pan = orbit_camera_pan;
	camera.roll = 0; //disable roll
	camera.tilt = -orbit_camera_tilt;
	
	sun_angle.pan += mouse_force.x * 15;
	sun_angle.pan %= 360;
	
	if(sun_tilt_halt != 1)
	{
		sun_angle.tilt += mouse_force.y * 10;
		sun_angle.tilt %= 360;
	}
	
	//move the camera when mouse is moved left or right
	orbit_camera_pan += mouse_force.x * 5;
	orbit_camera_pan = orbit_camera_pan%360;
	
	//tilt the camera with mouse movement
	orbit_camera_tilt += mouse_force.y * 5;
	
	if(bullet_existence == 0)
	{	
		if(key_1 == 1)
		{
			gun_ent.skin = 1;
			gun_blue = 1;
			gun_red = 0;
			gun_green = 0;
			gun_yellow = 0;
			if(resolution == 1)
			{
				guntable_mask_pan.pos_y = 263;	
			}
			if(resolution == 2)
			{
				guntable_mask_pan.pos_y = 328;
			}
			if(resolution == 3)
			{
				guntable_mask_pan.pos_y = 498;
			}
		}
		if(key_2 == 1)
		{
			gun_ent.skin = 2;
			gun_blue = 0;
			gun_red = 1;
			gun_green = 0;
			gun_yellow = 0;
			if(resolution == 1)
			{
				guntable_mask_pan.pos_y = 315;
			}
			if(resolution == 2)
			{
				guntable_mask_pan.pos_y = 394;
			}
			if(resolution == 3)
			{
				guntable_mask_pan.pos_y = 564;
			}
		}
		if(key_3 == 1)
		{
			gun_ent.skin = 3;
			gun_blue = 0;
			gun_red = 0;
			gun_green = 1;
			gun_yellow = 0;
			if(resolution == 1)
			{
				guntable_mask_pan.pos_y = 366;
			}
			if(resolution == 2)
			{
				guntable_mask_pan.pos_y = 460;
			}
			if(resolution == 3)
			{
				guntable_mask_pan.pos_y = 630;
			}
		}
		if(key_4 == 1)
		{
			gun_ent.skin = 4;
			gun_blue = 0;
			gun_red = 0;
			gun_green = 0;
			gun_yellow = 1;
			if(resolution == 1)
			{
				guntable_mask_pan.pos_y = 417;
			}
			if(resolution == 2)
			{
				guntable_mask_pan.pos_y = 525;
			}
			if(resolution == 3)
			{
				guntable_mask_pan.pos_y = 696;
			}
		}
	}
}

////Gun function//
//function gun_function()
//{
	//	vec_set(my.pos, camera.pos);	//make the gun follow the camera
	//	my.pan = camera.pan;				//gun pans with camera
	//	my.tilt = camera.tilt;			//gun tilts with camera
//}

//Cube particle//
function fade_function()
{
	my.alpha -= 4 * time;
	if(my.alpha < 0)
	{
		my.lifespan = 0;
	}
}

function particle_blue
{
	my.bmap = glow001_tga;
	my.red = random(50);
	my.green = random(50);
	my.blue = random(255);
	my.vel_x = random(6) - (6 / 2);
	my.vel_y = random(6) - (6 / 2);
	my.vel_z = random(5);
	my.size = 5;
	my.move = 1;
	my.alpha = 70;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_red
{
	my.bmap = glow001_tga;
	my.red = random(255);
	my.green = random(50);
	my.blue = random(50);
	my.vel_x = random(6) - (6 / 2);
	my.vel_y = random(6) - (6 / 2);
	my.vel_z = random(5);
	my.size = 5;
	my.move = 1;
	my.alpha = 70;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_green
{
	my.bmap = glow001_tga;
	my.red = random(50);
	my.green = random(255);
	my.blue = random(50);
	my.vel_x = random(6) - (6 / 2);
	my.vel_y = random(6) - (6 / 2);
	my.vel_z = random(5);
	my.size = 5;
	my.move = 1;
	my.alpha = 70;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_yellow
{
	my.bmap = glow001_tga;
	my.red = random(255);
	my.green = random(255);
	my.blue = random(50);
	my.vel_x = random(6) - (6 / 2);
	my.vel_y = random(6) - (6 / 2);
	my.vel_z = random(5);
	my.size = 5;
	my.move = 1;
	my.alpha = 70;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_bwhite
{
	my.bmap = glow001_tga;
	my.red = 230;
	my.green = 255;
	my.blue = 255;
	my.vel_x = random(6) - (6 / 2);
	my.vel_y = random(6) - (6 / 2);
	my.vel_z = random(5);
	my.size = 5;
	my.move = 1;
	my.alpha = 70;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_10p
{
	my.bmap = 10p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_15p
{
	my.bmap = 15p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_20p
{
	my.bmap = 20p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_25p
{
	my.bmap = 25p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_30p
{
	my.bmap = 30p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_40p
{
	my.bmap = 40p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_50p
{
	my.bmap = 50p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_75p
{
	my.bmap = 75p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

function particle_125p
{
	my.bmap = 75p_sprite_tga;
	my.red = 255;
	my.green = 255;
	my.blue = 255;
	my.vel_z = random(3);
	my.size = 3.5;
	my.move = 1;
	my.alpha = 50;
	my.transparent = 1;
	my.bright = 1;
	my.function = fade_function;
	my.flare = 1;
}

///Cube functions///
function cube_destruct()
{
	if(pause == 0)
	{
		cubes_shot += 1;
		if(my.skin == 1)
		{
			score += 10;
		}
		if(my.skin == 2 && my.skill22 == 0)
		{
			score += 15;
		}
		if(my.skin == 2 && my.skill22 == 1)
		{
			score += 75;
		}
		if(my.skin == 3 && my.skill22 == 0)
		{
			score += 15;
		}
		if(my.skin == 3 && my.skill22 == 1)
		{
			score += 75;
		}
		if(my.skin == 3 && my.skill22 == 2)
		{
			score += 75;
		}
		if(my.skin == 4)
		{
			score += 15;
		}
		if(my.skin == 5 || my.skin == 8 || my.skin == 9)
		{
			score += 20;
		}
		if(my.skin == 10)
		{
			score += 25;
		}
		if(my.skin == 11)
		{
			score += 30;
		}
		if(my.skin == 12)
		{
			score += 50;
		}
		if(my.skin == 14 || my.skin == 15)
		{
			score += 40;
		}
		if(my.skin == 16 || my.skin == 17)
		{
			score += 50;
		}
		if(my.skin == 13)
		{
			score += 75;
		}
		if(my.skin == 21)
		{
			score += 125;
		}
	}
	cube_amount -= 1;
	if(my.skin != 8 || my.skin != 9 || my.skin != 10 || my.skin != 11)
	{
		my.alpha = 100;
	}
	my.transparent = on;
	while(my.alpha > 0)
	{
		my.alpha -= 25 * time;
		wait(1);
	}
	if(my.skin == 1 || my.skin == 8 || my.skin == 14)
	{
		effect(particle_blue, 15, my.pos, normal);
	}
	if(my.skin == 2 || my.skin == 9 || my.skin == 15)
	{
		effect(particle_red, 15, my.pos, normal);
	}
	if(my.skin == 3 || my.skin == 10 || my.skin == 16)
	{
		effect(particle_green, 15, my.pos, normal);
	}
	if(my.skin == 4 || my.skin == 11 || my.skin == 17)
	{
		effect(particle_yellow, 15, my.pos, normal);
	}
	if(my.skin == 5 || my.skin == 6 || my.skin == 7 || my.skin == 12 || my.skin == 13 || my.skin == 21)
	{
		effect(particle_bwhite, 15, my.pos, normal);
	}
	//point particles
	if(pause == 0)
	{
		if(my.skin == 1)
		{
			effect(particle_10p,2,my.pos,normal);
		}
		if(my.skin == 2 && my.skill22 == 0)
		{
			effect(particle_15p,2,my.pos,normal);
		}
		if(my.skin == 2 && my.skill22 == 1)
		{
			effect(particle_75p,2,my.pos,normal);
		}
		if(my.skin == 3 && my.skill22 == 0)
		{
			effect(particle_15p,2,my.pos,normal);
		}
		if(my.skin == 3 && my.skill22 == 1)
		{
			effect(particle_75p,2,my.pos,normal);
		}
		if(my.skin == 3 && my.skill22 == 2)
		{
			effect(particle_75p,2,my.pos,normal);
		}
		if(my.skin == 4)
		{
			effect(particle_15p,2,my.pos,normal);
		}
		if(my.skin == 5 || my.skin == 8 || my.skin == 9)
		{
			effect(particle_20p,2,my.pos,normal);
		}
		if(my.skin == 10)
		{
			effect(particle_25p,2,my.pos,normal);
		}
		if(my.skin == 11)
		{
			effect(particle_30p,2,my.pos,normal);
		}
		if(my.skin == 12)
		{
			effect(particle_50p,2,my.pos,normal);
		}
		if(my.skin == 13)
		{
			effect(particle_75p,2,my.pos,normal);
		}
		if(my.skin == 14 || my.skin == 15)
		{
			effect(particle_40p,2,my.pos,normal);
		}
		if(my.skin == 16 || my.skin == 17)
		{
			effect(particle_40p,2,my.pos,normal);
		}
		if(my.skin == 18)
		{
			effect(particle_125p,2,my.pos,normal);
		}
	}
	if(pause == 0)
	{
		snd_play(cubedes_wav,sound_volume,0);
	}
	ent_remove(me);
}

function XDcube_event()
{
	if(my.skin == 1 && gun_blue == 1 && my.skill23 == 0)
	{
		my.skill30 = 0;
	}
	if(my.skin == 2 && gun_red == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 3 && gun_green == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 4 && gun_yellow == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 5)
	{
		my.skill30 = 0;
	}
	if(my.skin == 7)
	{
		my.skill30 = 0;
	}
	if(my.skin == 6)
	{
		snd_play(block_wav,sound_volume,0);
		my.skill30 -=1;
		my.skin = 7;
	}
	//stone events
	if(my.skin == 8 && my.skill30 == 1 && gun_blue == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 8 && my.skill30 == 2 && gun_blue == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 9 && my.skill30 == 1 && gun_red == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 9 && my.skill30 == 2 && gun_red == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 10 && my.skill30 == 1 && gun_green == 1 && my.skill23 == 0)
	{
		my.skill30 = 0;
	}
	if(my.skin == 10 && my.skill30 == 2 && gun_green == 1 && my.skill23 == 0)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 11 && my.skill30 == 1 && gun_yellow == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 11 && my.skill30 == 2 && gun_yellow == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	//ice events
	if(my.skin == 14 && my.skill30 == 1 && gun_blue == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 14 && my.skill30 == 2 && gun_blue == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 14 && my.skill30 == 3 && gun_blue == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 2;
		while(my.alpha > 75)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 15 && my.skill30 == 1 && gun_red == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 15 && my.skill30 == 2 && gun_red == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 15 && my.skill30 == 3 && gun_red == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 2;
		while(my.alpha > 75)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 16 && my.skill30 == 1 && gun_green == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 16 && my.skill30 == 2 && gun_green == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 16 && my.skill30 == 3 && gun_green == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 2;
		while(my.alpha > 75)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 17 && my.skill30 == 1 && gun_yellow == 1)
	{
		my.skill30 = 0;
	}
	if(my.skin == 17 && my.skill30 == 2 && gun_yellow == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 1;
		while(my.alpha > 50)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 17 && my.skill30 == 3 && gun_yellow == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.alpha = 100;
		my.transparent = on;
		my.skill30 = 2;
		while(my.alpha > 75)
		{
			my.alpha -= 10 * time;
			wait(1);
		}
	}
	if(my.skin == 12)
	{
		my.skill30 = 0;
	}
	if(my.skin == 13)
	{
		my.skill30 = 0;
	}
	if(my.skin == 18 && gun_blue == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.skill30 = 2;
		my.skin = 2;
	}
	if(my.skin == 19 && gun_blue == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.skill30 = 1;
		my.skin = 3;
	}
	if(my.skin == 20 && gun_red == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.skill30 = 1;
		my.skin = 3;
	}
	if(my.skin == 21)
	{
		my.skill30 = 0;
	}
	if(my.skin == 1 && my.skill23 == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.skill23 = 0;
		my.alpha = 100;
		my.skill30 = 1;
	}
	if(my.skin == 10 && my.skill23 == 1)
	{
		snd_play(block_wav,sound_volume,0);
		my.skill23 = 0;
		my.alpha = 100;
		my.skill30 = 2;
	}
}

function XDcube_func()
{
	my.polygon = on;
	my.enable_entity = on;
	my.enable_impact = on;
	if(level_number == 1)
	{
		my.skin = 1;
	}
	if(level_number == 2)
	{
		cube_number = int(random(2));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
	}
	if(level_number == 3)
	{
		cube_number = int(random(3));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 5;
		}
	}
	if(level_number == 4)
	{
		cube_number = int(random(4));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 5;
		}
	}
	if(level_number == 5)
	{
		cube_number = int(random(3));
		if(cube_number == 0)
		{
			my.skin = 2;
		}
		if(cube_number == 1)
		{
			my.skin = 3;
		}
		if(cube_number == 2)
		{
			my.skin = 5;
		}
	}
	if(level_number == 6)
	{
		cube_number = int(random(5));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 4;
		}
		if(cube_number == 4)
		{
			my.skin = 5;
		}
	}
	if(level_number == 7)
	{
		cube_number = int(random(6));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 4;
		}
		if(cube_number == 4)
		{
			my.skin = 5;
		}
		if(cube_number == 5)
		{
			my.skin = 6;
		}
	}
	if(level_number == 8)
	{
		cube_number = int(random(6));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 4;
		}
		if(cube_number == 4)
		{
			my.skin = 5;
		}
		if(cube_number == 5)
		{
			my.skin = 6;
		}
	}
	if(level_number == 9)
	{
		cube_number = int(random(4));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 5;
		}
		if(cube_number == 3)
		{
			my.skin = 8;
		}
	}
	if(level_number == 10)
	{
		cube_number = int(random(5));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 5;
		}
		if(cube_number == 3)
		{
			my.skin = 6;
		}
		if(cube_number == 4)
		{
			my.skin = 8;
		}
	}
	if(level_number == 11)
	{
		cube_number = int(random(5));
		if(cube_number == 0)
		{
			my.skin = 2;
		}
		if(cube_number == 1)
		{
			my.skin = 3;
		}
		if(cube_number == 2)
		{
			my.skin = 9;
		}
		if(cube_number == 3)
		{
			my.skin = 6;
		}
		if(cube_number == 4)
		{
			my.skin = 8;
		}
	}
	if(level_number == 12)
	{
		cube_number = int(random(7));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 9;
		}
		if(cube_number == 4)
		{
			my.skin = 6;
		}
		if(cube_number == 5)
		{
			my.skin = 8;
		}
		if(cube_number == 6)
		{
			my.skin = 5;
		}
	}
	if(level_number == 13)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 4;
		}
		if(cube_number == 4)
		{
			my.skin = 9;
		}
		if(cube_number == 5)
		{
			my.skin = 6;
		}
		if(cube_number == 6)
		{
			my.skin = 8;
		}
		if(cube_number == 7)
		{
			my.skin = 5;
		}
		if(cube_number == 8)
		{
			my.skin = 12;
		}
	}
	if(level_number == 14)
	{
		cube_number = int(random(7));
		if(cube_number == 0)
		{
			my.skin = 2;
		}
		if(cube_number == 1)
		{
			my.skin = 10;
		}
		if(cube_number == 2)
		{
			my.skin = 4;
		}
		if(cube_number == 3)
		{
			my.skin = 6;
		}
		if(cube_number == 4)
		{
			my.skin = 8;
		}
		if(cube_number == 5)
		{
			my.skin = 9;
		}
		if(cube_number == 6)
		{
			my.skin = 12;
		}
	}
	if(level_number == 15)
	{
		cube_number = int(random(6));
		if(cube_number == 0)
		{
			my.skin = 10;
		}
		if(cube_number == 1)
		{
			my.skin = 4;
		}
		if(cube_number == 2)
		{
			my.skin = 6;
		}
		if(cube_number == 3)
		{
			my.skin = 8;
		}
		if(cube_number == 4)
		{
			my.skin = 9;
		}
		if(cube_number == 5)
		{
			my.skin = 12;
		}
	}
	if(level_number == 16)
	{
		cube_number = int(random(7));
		if(cube_number == 0)
		{
			my.skin = 10;
		}
		if(cube_number == 1)
		{
			my.skin = 4;
		}
		if(cube_number == 2)
		{
			my.skin = 6;
		}
		if(cube_number == 3)
		{
			my.skin = 8;
		}
		if(cube_number == 4)
		{
			my.skin = 9;
		}
		if(cube_number == 5)
		{
			my.skin = 12;
		}
		if(cube_number == 6)
		{
			my.skin = 11;
		}
	}
	if(level_number == 17)
	{
		cube_number = int(random(6));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 8;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 10;
		}
		if(cube_number == 4)
		{
			my.skin = 13;
		}
		if(cube_number == 5)
		{
			my.skin = 9;
		}
	}
	if(level_number == 18)
	{
		cube_number = int(random(7));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 8;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 10;
		}
		if(cube_number == 4)
		{
			my.skin = 13;
		}
		if(cube_number == 5)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 9;
		}
	}
	if(level_number == 19)
	{
		cube_number = int(random(7));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 8;
		}
		if(cube_number == 2)
		{
			my.skin = 3;
		}
		if(cube_number == 3)
		{
			my.skin = 10;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 5)
		{
			my.skin = 2;
		}
		if(cube_number == 6)
		{
			my.skin = 9;
		}
	}
	if(level_number == 20)
	{
		cube_number = int(random(4));
		if(cube_number == 0)
		{
			my.skin = 5;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 12;
		}
		if(cube_number == 3)
		{
			my.skin = 13;
		}
	}
	if(level_number == 21)
	{
		cube_number = int(random(6));
		if(cube_number == 0)
		{
			my.skin = 14;
		}
		if(cube_number == 1)
		{
			my.skin = 15;
		}
		if(cube_number == 2)
		{
			my.skin = 4;
		}
		if(cube_number == 3)
		{
			my.skin = 11;
		}
		if(cube_number == 4)
		{
			my.skin = 13;
		}
		if(cube_number == 5)
		{
			my.skin = 6;
		}
	}
	if(level_number == 22)
	{
		cube_number = int(random(7));
		if(cube_number == 0)
		{
			my.skin = 14;
		}
		if(cube_number == 1)
		{
			my.skin = 15;
		}
		if(cube_number == 2)
		{
			my.skin = 4;
		}
		if(cube_number == 3)
		{
			my.skin = 11;
		}
		if(cube_number == 4)
		{
			my.skin = 13;
		}
		if(cube_number == 5)
		{
			my.skin = 6;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
	}
	if(level_number == 23)
	{
		cube_number = int(random(8));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 15;
		}
		if(cube_number == 2)
		{
			my.skin = 4;
		}
		if(cube_number == 3)
		{
			my.skin = 11;
		}
		if(cube_number == 4)
		{
			my.skin = 13;
		}
		if(cube_number == 5)
		{
			my.skin = 3;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
		if(cube_number == 7)
		{
			my.skin = 17;
		}
	}
	if(level_number == 24)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 8;
		}
		if(cube_number == 1)
		{
			my.skin = 2;
		}
		if(cube_number == 2)
		{
			my.skin = 11;
		}
		if(cube_number == 3)
		{
			my.skin = 4;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 5)
		{
			my.skin = 15;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
		if(cube_number == 7)
		{
			my.skin = 17;
		}
		if(cube_number == 8)
		{
			my.skin = 13;
		}
		if(cube_number == 8)
		{
			my.skin = 6;
		}
	}
	if(level_number == 25)
	{
		cube_number = int(random(7));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 12;
		}
		if(cube_number == 3)
		{
			my.skin = 13;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 5)
		{
			my.skin = 15;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
	}
	if(level_number == 26)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 12;
		}
		if(cube_number == 3)
		{
			my.skin = 13;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
		if(cube_number == 7)
		{
			my.skin = 11;
		}
		if(cube_number == 8)
		{
			my.skin = 18;
		}
	}
	if(level_number == 27)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 21;
		}
		if(cube_number == 3)
		{
			my.skin = 13;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
		if(cube_number == 7)
		{
			my.skin = 11;
		}
		if(cube_number == 8)
		{
			my.skin = 18;
		}
	}
	if(level_number == 28)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 1;
			my.skill23 = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 21;
		}
		if(cube_number == 3)
		{
			my.skin = 13;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
		if(cube_number == 7)
		{
			my.skin = 11;
		}
		if(cube_number == 8)
		{
			my.skin = 18;
		}
	}
	if(level_number == 29)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 1;
			my.skill23 = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 21;
		}
		if(cube_number == 3)
		{
			my.skin = 10;
			my.skill23 = 1;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
		if(cube_number == 7)
		{
			my.skin = 11;
		}
		if(cube_number == 8)
		{
			my.skin = 18;
		}
	}
	if(level_number == 30)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 1;
			my.skill23 = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 21;
		}
		if(cube_number == 3)
		{
			my.skin = 10;
			my.skill23 = 1;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 16;
		}
		if(cube_number == 7)
		{
			my.skin = 19;
		}
		if(cube_number == 8)
		{
			my.skin = 18;
		}
	}
	if(level_number == 31)
	{
		cube_number = int(random(9));
		if(cube_number == 0)
		{
			my.skin = 1;
			my.skill23 = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 21;
		}
		if(cube_number == 3)
		{
			my.skin = 10;
			my.skill23 = 1;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 20;
		}
		if(cube_number == 7)
		{
			my.skin = 19;
		}
		if(cube_number == 8)
		{
			my.skin = 18;
		}
	}
	if(level_number == 32)
	{
		cube_number = int(random(15));
		if(cube_number == 0)
		{
			my.skin = 1;
			my.skill23 = 1;
		}
		if(cube_number == 1)
		{
			my.skin = 6;
		}
		if(cube_number == 2)
		{
			my.skin = 21;
		}
		if(cube_number == 3)
		{
			my.skin = 10;
			my.skill23 = 1;
		}
		if(cube_number == 4)
		{
			my.skin = 14;
		}
		if(cube_number == 6)
		{
			my.skin = 20;
		}
		if(cube_number == 7)
		{
			my.skin = 19;
		}
		if(cube_number == 8)
		{
			my.skin = 18;
		}
		if(cube_number == 9)
		{
			my.skin = 2;
		}
		if(cube_number == 10)
		{
			my.skin = 4;
		}
		if(cube_number == 11)
		{
			my.skin = 15;
		}
		if(cube_number == 12)
		{
			my.skin = 16;
		}
		if(cube_number == 13)
		{
			my.skin = 6;
		}
		if(cube_number == 13)
		{
			my.skin = 5;
		}
	}
	my.event = XDcube_event;
	if(my.skin == 1 && my.skill23 == 0)
	{
		my.skill30 = 1;
	}
	if(my.skin == 2 || my.skin == 3 || my.skin == 4 || my.skin == 5 || my.skin == 12 || my.skin == 13 || my.skin == 21)
	{
		my.skill30 = 1;
	}
	if(my.skin == 6)
	{
		my.skill30 = 2;
	}
	if(my.skin == 8 || my.skin == 9|| my.skin == 11)
	{
		my.skill30 = 2;
	}
	if(my.skin == 10 && my.skill23 == 0)
	{
		my.skill30 = 2;
	}
	if(my.skin == 14 || my.skin == 15 || my.skin == 16 || my.skin == 17)
	{
		my.skill30 = 3;
	}
	if(my.skin == 18)
	{
		my.skill22 = 1;
		my.skill30 = 2;
	}
	if(my.skin == 19)
	{
		my.skill22 = 1;
		my.skill30 = 2;
	}
	if(my.skin == 20)
	{
		my.skill22 = 2;
		my.skill30 = 2;
	}
	if(my.skin == 1 && my.skill23 == 1)
	{
		my.alpha = 5;
		my.transparent = on;
		my.skill30 = 2;
	}
	if(my.skin == 10 && my.skill23 == 1)
	{
		my.alpha = 5;
		my.transparent = on;
		my.skill30 = 2;
	}
	cube_amount +=1;
	while(my.skill30 != 0 && pause == 0)
	{
		trace_mode = ignore_me+ignore_passable+use_box;
		temp_var = trace(my.x,vector(my.x,my.y,my.z - 4000));
		//		IF (you != null) { temp_var = ((my.z + you.min_z) - (you.z + you.max_z));	}	//Added by Axys Phenomenon
		if(temp_var > 0)
		{
			my.z -= 1.2*time;
		}
		wait(1);
	}
	cube_destruct();
}

//Bullet Functions//
function destroy_bullet()
{
	destroying_bullet = 1;
}

function bullet_func()
{
	my.enable_entity = on;
	my.event = destroy_bullet;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.z = camera.z -1;
	while(destroying_bullet != 1 && pause == 0)
	{
		bullet_dist.x = 0;
		bullet_dist.x += 20*time;
		move_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_SPRITES;
		ent_move(bullet_dist,nullvector);
		if(vec_dist(me.x,player.x) > 200)
		{
			destroying_bullet = 1;
		}
		wait(1);
	}
	ent_remove(me);
	bullet_existence = 0;
	destroying_bullet = 0;
}

function OKbutton_loadlev(newlev)
{ 
	level_clear = 0;
	levelclear_pan.visible = off;
	menu = 0;
	mouse_mode = 0;
	show_mouse = 0;
	sleep(0.5);
	level_number = newlev;
	ready_pan.transparent = on;
	ready_pan.alpha = 0;
	ready_pan.visible = on;
	while(ready_pan.alpha < 100)
	{
		ready_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(ready_wav,sound_volume,0);
	sleep(0.70);
	while(ready_pan.alpha > 0)
	{
		ready_pan.alpha -=20*time;
		wait(1);
	}
	ready_pan.visible = off;
	go_pan.transparent = on;
	go_pan.alpha = 0;
	go_pan.visible = on;
	while(go_pan.alpha < 100)
	{
		go_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(go_wav,sound_volume,0);
	sleep(0.50);
	while(go_pan.alpha > 0)
	{
		go_pan.alpha -=20*time;
		wait(1);
	}
	go_pan.visible = off;
	pause = 0;
}

//Button functions
function OKbutton_func()
{
	mouse_mode = 0;
	show_menu = 0;
	levelclear_pan.visible = off;
	level_clear = 0;
	if(level_number == 1 && cubes_shot == 25)
	{
		OKbutton_loadlev(2);
	}
	if(level_number == 2 && cubes_shot == 55)
	{
		OKbutton_loadlev(3);
	}
	if(level_number == 3 && cubes_shot == 85)
	{
		OKbutton_loadlev(4);
	}
	if(level_number == 4 && cubes_shot == 110)
	{
		OKbutton_loadlev(5);
	}
	if(level_number == 5 && cubes_shot == 150)
	{
		OKbutton_loadlev(6);
	}
	if(level_number == 6 && cubes_shot == 200)
	{
		OKbutton_loadlev(7);
	}
	if(level_number == 7 && cubes_shot == 260)
	{
		OKbutton_loadlev(8);
	}
	//	if(level_number == 8 && cubes_shot == 330)
	//	{
		//		OKbutton_pan.visible = off;
		//		congratulations_pan.alpha = 100;
		//		congratulations_pan.transparent = on;
		//		while(congratulations_pan.alpha > 0)
		//		{
			//			congratulations_pan.alpha -=20*time;
			//			wait(1);
		//		}
		//		congratulations_pan.visible = off;
		//		mouse_mode = 0;
		//		show_mouse = 0;
		//		sleep(0.5);
		//		OKbutton_pan.visible = off;
		//		level_number = 0;
		//		pause = 0;
	//	}
	if(level_number == 9 && cubes_shot == 40)
	{
		OKbutton_loadlev(10);
	}
	if(level_number == 10 && cubes_shot == 90)
	{
		OKbutton_loadlev(11);
	}
	if(level_number == 11 && cubes_shot == 160)
	{
		OKbutton_loadlev(12);
	}
	if(level_number == 12 && cubes_shot == 240)
	{
		OKbutton_loadlev(13);
	}
	if(level_number == 13 && cubes_shot == 340)
	{
		OKbutton_loadlev(14);
	}
	if(level_number == 14 && cubes_shot == 440)
	{
		OKbutton_loadlev(15);
	}
	if(level_number == 15 && cubes_shot == 530)
	{
		OKbutton_loadlev(16);
	}
	if(level_number == 17 && cubes_shot == 70)
	{
		OKbutton_loadlev(18);
	}
	if(level_number == 18 && cubes_shot == 150)
	{
		OKbutton_loadlev(19);
	}
	if(level_number == 19 && cubes_shot == 240)
	{
		OKbutton_loadlev(20);
	}
	if(level_number == 20 && cubes_shot == 340)
	{
		OKbutton_loadlev(21);
	}
	if(level_number == 21 && cubes_shot == 450)
	{
		OKbutton_loadlev(22);
	}
	if(level_number == 22 && cubes_shot == 550)
	{
		OKbutton_loadlev(23);
	}
	if(level_number == 23 && cubes_shot == 660)
	{
		OKbutton_loadlev(24);
	}
	if(level_number == 25 && cubes_shot == 70)
	{
		OKbutton_loadlev(26);
	}
	if(level_number == 26 && cubes_shot == 140)
	{
		OKbutton_loadlev(27);
	}
	if(level_number == 27 && cubes_shot == 220)
	{
		OKbutton_loadlev(28);
	}
	if(level_number == 28 && cubes_shot == 310)
	{
		OKbutton_loadlev(29);
	}
	if(level_number == 29 && cubes_shot == 420)
	{
		OKbutton_loadlev(30);
	}
	if(level_number == 30 && cubes_shot == 530)
	{
		OKbutton_loadlev(31);
	}
	if(level_number == 31 && cubes_shot == 650)
	{
		OKbutton_loadlev(32);
	}
	freeze_mode = 0;
}

function OKbutton2_func()
{
	if(level_number == 8 && cubes_shot == 330)
	{
	worldclear_pan.visible = off;
		mouse_mode = 0;
		show_mouse = 0;
		sleep(0.5);
		black_pan.visible = on;
		level001 = 0;
		level002 = 1;
		world = 2;
		level_number = 9;
		cubes_shot = 0;
		ready_pan.transparent = on;
		ready_pan.alpha = 0;
		ready_pan.visible = on;
		while(ready_pan.alpha < 100)
		{
			ready_pan.alpha +=20*time;
			wait(1);
		}
		sleep(0.70);
		snd_play(ready_wav,sound_volume,0);
		while(ready_pan.alpha > 0)
		{
			ready_pan.alpha -=20*time;
			wait(1);
		}
		ready_pan.visible = off;
		go_pan.transparent = on;
		go_pan.alpha = 0;
		go_pan.visible = on;
		while(go_pan.alpha < 100)
		{
			go_pan.alpha +=20*time;
			wait(1);
		}
		snd_play(go_wav,sound_volume,0);
		sleep(0.50);
		while(go_pan.alpha > 0)
		{
			go_pan.alpha -=20*time;
			wait(1);
		}
		go_pan.visible = off;
		pause = 0;
		black_pan.visible = off;
		level_clear = 0;
	}
	if(level_number == 16 && cubes_shot == 630)
	{
		worldclear_pan.visible = off;
		mouse_mode = 0;
		show_mouse = 0;
		sleep(0.5);
		black_pan.visible = on;
		level002 = 0;
		level003 = 1;
		world = 3;
		level_number = 17;
		cubes_shot = 0;
		ready_pan.transparent = on;
		ready_pan.alpha = 0;
		ready_pan.visible = on;
		while(ready_pan.alpha < 100)
		{
			ready_pan.alpha +=20*time;
			wait(1);
		}
		snd_play(ready_wav,sound_volume,0);
		sleep(0.70);
		while(ready_pan.alpha > 0)
		{
			ready_pan.alpha -=20*time;
			wait(1);
		}
		ready_pan.visible = off;
		go_pan.transparent = on;
		go_pan.alpha = 0;
		go_pan.visible = on;
		while(go_pan.alpha < 100)
		{
			go_pan.alpha +=20*time;
			wait(1);
		}
		snd_play(go_wav,sound_volume,0);
		sleep(0.50);
		while(go_pan.alpha > 0)
		{
			go_pan.alpha -=20*time;
			wait(1);
		}
		go_pan.visible = off;
		pause = 0;
		black_pan.visible = off;
		level_clear = 0;
	}
	if(level_number == 24 && cubes_shot == 770)
	{
		worldclear_pan.visible = off;
		mouse_mode = 0;
		show_mouse = 0;
		sleep(0.5);
		black_pan.visible = on;
		level003 = 0;
		level004 = 1;
		world = 4;
		level_number = 25;
		cubes_shot = 0;
		ready_pan.transparent = on;
		ready_pan.alpha = 0;
		ready_pan.visible = on;
		while(ready_pan.alpha < 100)
		{
			ready_pan.alpha +=20*time;
			wait(1);
		}
		snd_play(ready_wav,sound_volume,0);
		sleep(0.70);
		while(ready_pan.alpha > 0)
		{
			ready_pan.alpha -=20*time;
			wait(1);
		}
		ready_pan.visible = off;
		go_pan.transparent = on;
		go_pan.alpha = 0;
		go_pan.visible = on;
		while(go_pan.alpha < 100)
		{
			go_pan.alpha +=20*time;
			wait(1);
		}
		snd_play(go_wav,sound_volume,0);
		sleep(0.50);
		while(go_pan.alpha > 0)
		{
			go_pan.alpha -=20*time;
			wait(1);
		}
		go_pan.visible = off;
		pause = 0;
		black_pan.visible = off;
		level_clear = 0;
	}
}

function game_over()
{
	level_clear = 1;
	game_over_var = 1;
	if(cubes_shot < 800)
	{
		media_play(gameov_ogg,null,sound_volume);
	}
	if(cubes_shot < 800)
	{
		game_over_pan.transparent = on;
		game_over_pan.alpha = 0;
		game_over_pan.visible = on;
		while(game_over_pan.alpha < 100)
		{
			game_over_pan.alpha +=10*time;
			wait(1);
		}
	}
	sleep(3);
	game_over_pan.visible = off;
	pause = 1;
	mode_blockattack = 0;
	level_number = 0;
	level001 = 0;
	level001_loaded = 0;
	level002 = 0;
	level002_loaded = 0;
	level003 = 0;
	level003_loaded = 0;
	level004 = 0;
	level004_loaded = 0;
	cubes_shot = 0;
	cube_amount = 0;
	old_level = 0;
	if(score > 1hscore5 && score <= 1hscore4)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_var_write(filehandle,score);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_close(filehandle);
}
if(score > 1hscore4 && score <= 1hscore3)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}
if(score > 1hscore3 && score <= 1hscore2)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}
if(score > 1hscore2 && score <= 1hscore1)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}
if(score > 1hscore1)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}
	score = 0;
	gun_ent.visible = off;
	score_pan.visible = off;
	guntable_pan.visible = off;
	guntable_mask_pan.visible = off;
	if(danke_pan.visible == on)
	{
		danke_pan.visible = off;
	}
	menu = 1;
}

material level001_mat
{
	diffuse_red = 0;
	diffuse_green = 0;
	diffuse_blue = 100;
}

function level001_func()
{
	my.ambient = -80;
	my.material = level001_mat;
	my.passable = on;
	my.size = 1.159;
	while(level001 == 1)
	{
		wait(1);
	}
	ent_remove(me);
}

material level002_mat
{
	diffuse_red = 50;
	diffuse_green = 50;
	diffuse_blue = 0;
}

function level002_func()
{
	my.ambient = 0;
	my.material = level002_mat;
	my.passable = on;
	my.size = 1.159;
	while(level002 == 1)
	{
		wait(1);
	}
	ent_remove(me);
}

material level003_mat
{
	diffuse_red = 0;
	diffuse_green = 0;
	diffuse_blue = 20;
}

function level003_func()
{
	my.ambient = 0;
	my.material = level003_mat;
	my.passable = on;
	my.size = 1.159;
	while(level003 == 1)
	{
		wait(1);
	}
	ent_remove(me);
}

material level004_mat
{
	diffuse_red = 255;
	diffuse_green = 128;
	diffuse_blue = 0;
}

function level004_func()
{
	my.ambient = 0;
	my.material = level004_mat;
	my.passable = on;
	my.size = 0.9;
	while(level004 == 1)
	{
		wait(1);
	}
	ent_remove(me);
}

function playgame_func()
{
	snd_play(click_wav,sound_volume,0);
	1highscore_pan.visible = off;
	1highscore_txt.visible = off;
	menu_but_pan.visible = off;
	while(menu_bg1_pan.alpha > 0)
	{
		menu_bg1_pan.alpha -=7*time;
		wait(1);
	}
	menu_bg1_pan.visible = off;
	level_but_pan.visible = on;
	return_pan.visible = on;
}

function quit_func()
{
	exit;
}

function return_func()
{
	return_pan.visible = off;
	level_but_pan.visible = off;
	options_pan.visible = off;
	filehandle = file_open_write("configuration.txt");
	file_var_write(filehandle,resolution);
	file_var_write(filehandle,sound_volume);
	file_var_write(filehandle,music_volume);
	file_close(filehandle);
	if(resolution != temp_var)
	{
		if(resolution < 1.5)
	{
		black_pan.size_x = 640; 
		black_pan.size_y = 480; 
		menu_bg2_pan.bmap = menu_bg2_640_jpg;
		menu_bg2_pan.size_x = 640;
		menu_bg2_pan.size_y = 480;
		menu_bg1_pan.bmap = menu_bg1_640_jpg;
		menu_bg1_pan.size_x = 640;
		menu_bg1_pan.size_y = 480;
		menu_but_pan.pos_x = 140;
		menu_but_pan.pos_y = 40;
		level_but_pan.scale_x = 0.625;
		level_but_pan.scale_y = 0.625;
		options_pan.pos_x = 170;
		options_pan.pos_y = 140;
		return_pan.scale_x = 0.625;
		return_pan.scale_y = 0.625;
		return_pan.pos_y = 0;
		returntomenu_pan.pos_x = 490;
		returntomenu_pan.pos_y = 418;
		guntable_pan.scale_x = 0.78125;
		guntable_pan.scale_y = 0.78125;
		guntable_pan.pos_y = 265;
		guntable_mask_pan.scale_x = 0.78125;
		guntable_mask_pan.scale_y = 0.78125;
		guntable_mask_pan.pos_y = 263;
		ready_pan.bmap = ready_640_jpg;
		ready_pan.size_x = 640;
		ready_pan.size_y = 56;
		ready_pan.pos_y = 160;
		go_pan.bmap = go_640_jpg;
		go_pan.size_x = 640;
		go_pan.size_y = 56;
		go_pan.pos_y = 160;
		game_over_pan.bmap = game_over_640_jpg;
		game_over_pan.size_x = 640;
		game_over_pan.size_y = 63;
		game_over_pan.pos_y = 160;
		worldclear_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 150;
		OKbutton_pan.pos_y = 115;
		OKbutton2_pan.pos_x = 150;
		OKbutton2_pan.pos_y = 115;
		instructions_pan.bmap = instructions_640_jpg;
		instructions_pan.size_x = 640;
		instructions_pan.size_y = 480;
		instructions_pan.pos_x = 0;
		instructions_pan.pos_y = 0;
		compcongmes_pan.pos_x = 0;
		compcongmes_pan.pos_y = 0;
		danke_pan.pos_x = 0;
		danke_pan.pos_y = 0;
		1highscore_pan.pos_x = 640/8;
		1highscore_pan.pos_y = 480/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 480/2;
		ingamemenu_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(6,0,0);
	}
	if(resolution >= 1.5 && resolution < 2.5)
	{
		black_pan.size_x = 800; 
		black_pan.size_y = 600; 
		menu_bg2_pan.bmap = menu_bg2_800_jpg;
		menu_bg2_pan.size_x = 800;
		menu_bg2_pan.size_y = 600;
		menu_bg1_pan.bmap = menu_bg1_800_jpg;
		menu_bg1_pan.size_x = 800;
		menu_bg1_pan.size_y = 600;
		menu_but_pan.pos_x = 200;
		menu_but_pan.pos_y = 100;
		level_but_pan.scale_x = 0.78125;
		level_but_pan.scale_y = 0.78125;
		options_pan.pos_x = 250;
		options_pan.pos_y = 200;
		return_pan.scale_x = 1;
		return_pan.scale_y = 1;
		return_pan.pos_y = -168;
		returntomenu_pan.pos_x = 650;
		returntomenu_pan.pos_y = 538;
		guntable_pan.scale_x = 1;
		guntable_pan.scale_y = 1;
		guntable_pan.pos_y = 330;
		guntable_mask_pan.scale_x = 1;
		guntable_mask_pan.scale_y = 1;
		guntable_mask_pan.pos_y = 328;
		ready_pan.bmap = ready_800_jpg;
		ready_pan.size_x = 800;
		ready_pan.size_y = 70;
		ready_pan.pos_y = 200;
		go_pan.bmap = go_800_jpg;
		go_pan.size_x = 800;
		go_pan.size_y = 70;
		go_pan.pos_y = 200;
		game_over_pan.bmap = game_over_800_jpg;
		game_over_pan.size_x = 800;
		game_over_pan.size_y = 78;
		game_over_pan.pos_y = 200;
		worldclear_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 230;
		OKbutton_pan.pos_y = 160;
		OKbutton2_pan.pos_x = 230;
		OKbutton2_pan.pos_y = 160;
		instructions_pan.bmap = instructions_800_jpg;
		instructions_pan.size_x = 800;
		instructions_pan.size_y = 600;
		instructions_pan.pos_x = 0;
		instructions_pan.pos_y = 0;
		danke_pan.pos_x = 80;
		danke_pan.pos_y = 60;
		compcongmes_pan.pos_x = 80;
		compcongmes_pan.pos_y = 60;
		1highscore_pan.pos_x = 800/8;
		1highscore_pan.pos_y = 600/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 600/2;
		ingamemenu_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(7,0,0);
	}
	if(resolution >= 2.5)
	{
		black_pan.size_x = 1024; 
		black_pan.size_y = 768; 
		menu_bg2_pan.bmap = menu_bg2_jpg;
		menu_bg2_pan.size_x = 1024;
		menu_bg2_pan.size_y = 768;
		menu_bg1_pan.bmap = menu_bg1_jpg;
		menu_bg1_pan.size_x = 1024;
		menu_bg1_pan.size_y = 768;
		menu_but_pan.pos_x = 312;
		menu_but_pan.pos_y = 184;
		level_but_pan.scale_x = 1;
		level_but_pan.scale_y = 1;
		options_pan.pos_x = 362;
		options_pan.pos_y = 284;
		return_pan.scale_x = 1;
		return_pan.scale_y = 1;
		return_pan.pos_y = 0;
		returntomenu_pan.pos_x = 874;
		returntomenu_pan.pos_y = 706;
		guntable_pan.scale_x = 1;
		guntable_pan.scale_y = 1;
		guntable_pan.pos_y = 500;
		guntable_mask_pan.scale_x = 1;
		guntable_mask_pan.scale_y = 1;
		guntable_mask_pan.pos_y = 498;
		ready_pan.bmap = ready_jpg;
		ready_pan.size_x = 1024;
		ready_pan.size_y = 90;
		ready_pan.pos_y = 250;
		go_pan.bmap = go_jpg;
		go_pan.size_x = 1024;
		go_pan.size_y = 90;
		go_pan.pos_y = 250;
		game_over_pan.bmap = game_over_jpg;
		game_over_pan.size_x = 1024;
		game_over_pan.size_y = 100;
		game_over_pan.pos_y = 250;
		worldclear_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 342;
		OKbutton_pan.pos_y = 200;
		OKbutton2_pan.pos_x = 342;
		OKbutton2_pan.pos_y = 200;
		instructions_pan.bmap = instructions_800_jpg;
		instructions_pan.size_x = 800;
		instructions_pan.size_y = 600;
		instructions_pan.pos_x = 112;
		instructions_pan.pos_y = 84;
		danke_pan.pos_x = 192;
		danke_pan.pos_y = 144;
		compcongmes_pan.pos_x = 192;
		compcongmes_pan.pos_y = 144;
		1highscore_pan.pos_x = 1024/8;
		1highscore_pan.pos_y = 768/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 768/2;
		ingamemenu_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(8,0,0);
	}	
		
		
		temp_var=resolution;
	}
	menu_bg1_pan.visible = on;
	while(menu_bg1_pan.alpha < 100)
	{
		menu_bg1_pan.alpha +=7*time;
		wait(1);
	}
	menu_but_pan.visible = on;
	1highscore_pan.visible = on;
	1highscore_txt.visible = on;
	in_options = 0;
}

function returntomenu_func()
{
	mouse_mode = 0;
	show_mouse = 0;
	OKbutton_pan.visible = off;
	OKbutton2_pan.visible = off;
	congratulations_pan.visible = off;
	congratulations2_pan.visible = off;
	returntomenu_pan.visible = off;
	pause = 1;
	mode_blockattack = 0;
	level_number = 0;
	level001 = 0;
	level001_loaded = 0;
	level002 = 0;
	level002_loaded = 0;
	level003 = 0;
	level003_loaded = 0;
	level004 = 0;
	level004_loaded = 0;
	cubes_shot = 0;
	cube_amount = 0;
	if(score > 1hscore5 && score <= 1hscore4)
	{
		filehandle = file_open_write("hs1.txt");
		file_var_write(filehandle,1hscore1);
		file_var_write(filehandle,1hscore2);
		file_var_write(filehandle,1hscore3);
		file_var_write(filehandle,1hscore4);
		file_var_write(filehandle,score);
		file_str_write(filehandle,1hscorepl1);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl2);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl3);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl4);
		file_str_write(filehandle,",");
		file_str_write(filehandle,playername);
		file_close(filehandle);
	}
	if(score > 1hscore4 && score <= 1hscore3)
	{
		filehandle = file_open_write("hs1.txt");
		file_var_write(filehandle,1hscore1);
		file_var_write(filehandle,1hscore2);
		file_var_write(filehandle,1hscore3);
		file_var_write(filehandle,score);
		file_var_write(filehandle,1hscore4);
		file_str_write(filehandle,1hscorepl1);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl2);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl3);
		file_str_write(filehandle,",");
		file_str_write(filehandle,playername);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl4);
		file_close(filehandle);
	}
	if(score > 1hscore3 && score <= 1hscore2)
	{
		filehandle = file_open_write("hs1.txt");
		file_var_write(filehandle,1hscore1);
		file_var_write(filehandle,1hscore2);
		file_var_write(filehandle,score);
		file_var_write(filehandle,1hscore4);
		file_var_write(filehandle,1hscore5);
		file_str_write(filehandle,1hscorepl1);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl2);
		file_str_write(filehandle,",");
		file_str_write(filehandle,playername);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl3);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl4);
		file_close(filehandle);
	}
	if(score > 1hscore2 && score <= 1hscore1)
	{
		filehandle = file_open_write("hs1.txt");
		file_var_write(filehandle,1hscore1);
		file_var_write(filehandle,score);
		file_var_write(filehandle,1hscore3);
		file_var_write(filehandle,1hscore4);
		file_var_write(filehandle,1hscore5);
		file_str_write(filehandle,1hscorepl1);
		file_str_write(filehandle,",");
		file_str_write(filehandle,playername);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl2);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl3);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl4);
		file_close(filehandle);
	}
	if(score > 1hscore1)
	{
		filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
		file_str_write(filehandle,playername);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl1);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl2);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl3);
		file_str_write(filehandle,",");
		file_str_write(filehandle,1hscorepl4);
		file_close(filehandle);
	}
	score = 0;
	gun_ent.visible = off;
	score_pan.visible = off;
	guntable_pan.visible = off;
	guntable_mask_pan.visible = off;
	menu = 1;
	pause = 0;
}

function levprev001_func()
{
	snd_play(sellevel_wav,sound_volume,0);
	level_clear = 0;
	menu = 0;
	1highscore_pan.visible = off;
	1highscore_txt.visible = off;
	menu_bg1_pan.visible = off;
	level_but_pan.visible = off;
	return_pan.visible = off;
	mouse_mode = 0;
	show_mouse = 0;
	while(menu_bg2_pan.alpha > 0)
	{
		menu_bg2_pan.alpha -=7*time;
		wait(1);
	}
	menu_bg2_pan.visible = off;
	show_menu = 0;
	sleep(1);
	gun_ent.visible = on;
	score_pan.visible = on;
	guntable_pan.visible = on;
	guntable_mask_pan.visible = on;
	mode_blockattack = 1;
	level001 = 1;
	level_number = 1;
	//show ready go pans
	ready_pan.transparent = on;
	ready_pan.alpha = 0;
	ready_pan.visible = on;
	while(ready_pan.alpha < 100)
	{
		ready_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(ready_wav,sound_volume,0);
	sleep(0.70);
	while(ready_pan.alpha > 0)
	{
		ready_pan.alpha -=20*time;
		wait(1);
	}
	ready_pan.visible = off;
	go_pan.transparent = on;
	go_pan.alpha = 0;
	go_pan.visible = on;
	while(go_pan.alpha < 100)
	{
		go_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(go_wav,sound_volume,0);
	sleep(0.50);
	while(go_pan.alpha > 0)
	{
		go_pan.alpha -=20*time;
		wait(1);
	}
	go_pan.visible = off;
	pause = 0;
	black_pan.visible = off;
	world = 1;
}

function levprev002_func()
{
	snd_play(sellevel_wav,sound_volume,0);
	level_clear = 0;
	menu = 0;
	menu_bg1_pan.visible = off;
	level_but_pan.visible = off;
	1highscore_pan.visible = off;
	1highscore_txt.visible = off;
	return_pan.visible = off;
	mouse_mode = 0;
	show_mouse = 0;
	while(menu_bg2_pan.alpha > 0)
	{
		menu_bg2_pan.alpha -=7*time;
		wait(1);
	}
	menu_bg2_pan.visible = off;
	show_menu = 0;
	sleep(1);
	gun_ent.visible = on;
	score_pan.visible = on;
	guntable_pan.visible = on;
	guntable_mask_pan.visible = on;
	mode_blockattack = 1;
	level002 = 1;
	level_number = 9;
	//show ready go pans
	ready_pan.transparent = on;
	ready_pan.alpha = 0;
	ready_pan.visible = on;
	while(ready_pan.alpha < 100)
	{
		ready_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(ready_wav,sound_volume,0);
	sleep(0.70);
	while(ready_pan.alpha > 0)
	{
		ready_pan.alpha -=20*time;
		wait(1);
	}
	ready_pan.visible = off;
	go_pan.transparent = on;
	go_pan.alpha = 0;
	go_pan.visible = on;
	while(go_pan.alpha < 100)
	{
		go_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(go_wav,sound_volume,0);
	sleep(0.50);
	while(go_pan.alpha > 0)
	{
		go_pan.alpha -=20*time;
		wait(1);
	}
	go_pan.visible = off;
	pause = 0;
	black_pan.visible = off;
	world = 2;
}

function levprev003_func()
{
	snd_play(sellevel_wav,sound_volume,0);
	level_clear = 0;
	menu = 0;
	menu_bg1_pan.visible = off;
	level_but_pan.visible = off;
	1highscore_pan.visible = off;
	1highscore_txt.visible = off;
	return_pan.visible = off;
	mouse_mode = 0;
	show_mouse = 0;
	while(menu_bg2_pan.alpha > 0)
	{
		menu_bg2_pan.alpha -=7*time;
		wait(1);
	}
	menu_bg2_pan.visible = off;
	show_menu = 0;
	sleep(1);
	gun_ent.visible = on;
	score_pan.visible = on;
	guntable_pan.visible = on;
	guntable_mask_pan.visible = on;
	mode_blockattack = 1;
	level003 = 1;
	level_number = 17;
	//show ready go pans
	ready_pan.transparent = on;
	ready_pan.alpha = 0;
	ready_pan.visible = on;
	while(ready_pan.alpha < 100)
	{
		ready_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(ready_wav,sound_volume,0);
	sleep(0.70);
	while(ready_pan.alpha > 0)
	{
		ready_pan.alpha -=20*time;
		wait(1);
	}
	ready_pan.visible = off;
	go_pan.transparent = on;
	go_pan.alpha = 0;
	go_pan.visible = on;
	while(go_pan.alpha < 100)
	{
		go_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(go_wav,sound_volume,0);
	sleep(0.50);
	while(go_pan.alpha > 0)
	{
		go_pan.alpha -=20*time;
		wait(1);
	}
	go_pan.visible = off;
	pause = 0;
	black_pan.visible = off;
	world = 3;
}

function levprev004_func()
{
	snd_play(sellevel_wav,sound_volume,0);
	level_clear = 0;
	menu = 0;
	menu_bg1_pan.visible = off;
	level_but_pan.visible = off;
	1highscore_pan.visible = off;
	1highscore_txt.visible = off;
	return_pan.visible = off;
	mouse_mode = 0;
	show_mouse = 0;
	while(menu_bg2_pan.alpha > 0)
	{
		menu_bg2_pan.alpha -=7*time;
		wait(1);
	}
	menu_bg2_pan.visible = off;
	show_menu = 0;
	sleep(1);
	gun_ent.visible = on;
	score_pan.visible = on;
	guntable_pan.visible = on;
	guntable_mask_pan.visible = on;
	mode_blockattack = 1;
	level004 = 1;
	level_number = 25;
	//show ready go pans
	ready_pan.transparent = on;
	ready_pan.alpha = 0;
	ready_pan.visible = on;
	while(ready_pan.alpha < 100)
	{
		ready_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(ready_wav,sound_volume,0);
	sleep(0.70);
	while(ready_pan.alpha > 0)
	{
		ready_pan.alpha -=20*time;
		wait(1);
	}
	ready_pan.visible = off;
	go_pan.transparent = on;
	go_pan.alpha = 0;
	go_pan.visible = on;
	while(go_pan.alpha < 100)
	{
		go_pan.alpha +=20*time;
		wait(1);
	}
	snd_play(go_wav,sound_volume,0);	
	sleep(0.50);
	while(go_pan.alpha > 0)
	{
		go_pan.alpha -=20*time;
		wait(1);
	}
	go_pan.visible = off;
	pause = 0;
	black_pan.visible = off;
	world = 4;
}
}

function options_func()
{
snd_play(click_wav,sound_volume,0);
1highscore_pan.visible = off;
1highscore_txt.visible = off;
menu_but_pan.visible = off;
while(menu_bg1_pan.alpha > 0)
{
	menu_bg1_pan.alpha -=7*time;
	wait(1);
}
menu_bg1_pan.visible = off;
options_pan.visible = on;
return_pan.visible = on;
in_options = 1;
media_stop(music_handle1);
}

function mouseon_func()
{
snd_play(mouseon_wav,sound_volume,0);
}

function show_congrats()
{
if(pause == 0)
{
	pause = 1;
	if(level_number > old_level)
	{
		level_clear = 1;
		old_level = level_number;
		congratulations_pan.pos_x = screen_size.x/2 - bmap_width(congratulations_tga)/2;
		congratulations_pan.pos_y = screen_size.y/2 - bmap_height(congratulations_tga)/2;
		congratulations_pan.alpha = 100;
		congratulations_pan.transparent = on;
		congratulations_pan.visible = on;
		sleep(2);
		while(congratulations_pan.alpha > 0)
		{
			congratulations_pan.alpha -= 4 * Time;
			wait(1);
		}
		congratulations_pan.visible = off;
		levelclear_pan.pos_x = screen_size.x/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = screen_size.y/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.visible = on;
		if(show_mouse == 0)
		{
			mouse_mode = 2;
			show_mouse = 1;
		}
	}
}
}
function igquitas_func(); //protoype placed randomly xD

function show_congratsend()
{
if(pause == 0)
{
	pause = 1;
	sleep(1);
	gun_ent.visible = off;
	score_pan.visible = off;
	guntable_pan.visible = off;
	guntable_mask_pan.visible = off;
	black_pan.visible = on;
	level004 = 0;
	game_over_var = 1;
	media_play(congrats_ogg,null,sound_volume);
	compcongmes_pan.transparent = on;
	compcongmes_pan.alpha = 0;
	compcongmes_pan.visible = on;
	while(compcongmes_pan.alpha < 100)
	{
		compcongmes_pan.alpha +=4*time;
		wait(1);
	}
	while(key_any == 0)
	{
		wait(1);
	}
	compcongmes_pan.visible = off;
	igquitas_func();
}
}

function closeme_func
{
ingamemenu_pan.visible = off;
mouse_mode = 0;
freeze_mode = 0;
}


function igoptions_func
{
igoptions_pan.pos_x = ingamemenu_pan.pos_x;
igoptions_pan.pos_y = ingamemenu_pan.pos_y;
igoptions_pan.visible = on;
}

function closeop_func
{
igoptions_pan.visible = off;
filehandle = file_open_write("configuration.txt");
file_var_write(filehandle,resolution);
file_var_write(filehandle,sound_volume);
file_var_write(filehandle,music_volume);
file_close(filehandle);
if(resolution != temp_var)
{
	if(resolution < 1.5)
	{
		black_pan.size_x = 640; 
		black_pan.size_y = 480; 
		menu_bg2_pan.bmap = menu_bg2_640_jpg;
		menu_bg2_pan.size_x = 640;
		menu_bg2_pan.size_y = 480;
		menu_bg1_pan.bmap = menu_bg1_640_jpg;
		menu_bg1_pan.size_x = 640;
		menu_bg1_pan.size_y = 480;
		menu_but_pan.pos_x = 140;
		menu_but_pan.pos_y = 40;
		level_but_pan.scale_x = 0.625;
		level_but_pan.scale_y = 0.625;
		options_pan.pos_x = 170;
		options_pan.pos_y = 140;
		return_pan.scale_x = 0.625;
		return_pan.scale_y = 0.625;
		return_pan.pos_y = 0;
		returntomenu_pan.pos_x = 490;
		returntomenu_pan.pos_y = 418;
		guntable_pan.scale_x = 0.78125;
		guntable_pan.scale_y = 0.78125;
		guntable_pan.pos_y = 265;
		guntable_mask_pan.scale_x = 0.78125;
		guntable_mask_pan.scale_y = 0.78125;
		guntable_mask_pan.pos_y = 263;
		ready_pan.bmap = ready_640_jpg;
		ready_pan.size_x = 640;
		ready_pan.size_y = 56;
		ready_pan.pos_y = 160;
		go_pan.bmap = go_640_jpg;
		go_pan.size_x = 640;
		go_pan.size_y = 56;
		go_pan.pos_y = 160;
		game_over_pan.bmap = game_over_640_jpg;
		game_over_pan.size_x = 640;
		game_over_pan.size_y = 63;
		game_over_pan.pos_y = 160;
		worldclear_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 150;
		OKbutton_pan.pos_y = 115;
		OKbutton2_pan.pos_x = 150;
		OKbutton2_pan.pos_y = 115;
		instructions_pan.bmap = instructions_640_jpg;
		instructions_pan.size_x = 640;
		instructions_pan.size_y = 480;
		instructions_pan.pos_x = 0;
		instructions_pan.pos_y = 0;
		compcongmes_pan.pos_x = 0;
		compcongmes_pan.pos_y = 0;
		danke_pan.pos_x = 0;
		danke_pan.pos_y = 0;
		1highscore_pan.pos_x = 640/8;
		1highscore_pan.pos_y = 480/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 480/2;
		ingamemenu_pan.pos_x = 640/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 480/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(6,0,0);
	}
	if(resolution >= 1.5 && resolution < 2.5)
	{
		black_pan.size_x = 800; 
		black_pan.size_y = 600; 
		menu_bg2_pan.bmap = menu_bg2_800_jpg;
		menu_bg2_pan.size_x = 800;
		menu_bg2_pan.size_y = 600;
		menu_bg1_pan.bmap = menu_bg1_800_jpg;
		menu_bg1_pan.size_x = 800;
		menu_bg1_pan.size_y = 600;
		menu_but_pan.pos_x = 200;
		menu_but_pan.pos_y = 100;
		level_but_pan.scale_x = 0.78125;
		level_but_pan.scale_y = 0.78125;
		options_pan.pos_x = 250;
		options_pan.pos_y = 200;
		return_pan.scale_x = 1;
		return_pan.scale_y = 1;
		return_pan.pos_y = -168;
		returntomenu_pan.pos_x = 650;
		returntomenu_pan.pos_y = 538;
		guntable_pan.scale_x = 1;
		guntable_pan.scale_y = 1;
		guntable_pan.pos_y = 330;
		guntable_mask_pan.scale_x = 1;
		guntable_mask_pan.scale_y = 1;
		guntable_mask_pan.pos_y = 328;
		ready_pan.bmap = ready_800_jpg;
		ready_pan.size_x = 800;
		ready_pan.size_y = 70;
		ready_pan.pos_y = 200;
		go_pan.bmap = go_800_jpg;
		go_pan.size_x = 800;
		go_pan.size_y = 70;
		go_pan.pos_y = 200;
		game_over_pan.bmap = game_over_800_jpg;
		game_over_pan.size_x = 800;
		game_over_pan.size_y = 78;
		game_over_pan.pos_y = 200;
		worldclear_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 230;
		OKbutton_pan.pos_y = 160;
		OKbutton2_pan.pos_x = 230;
		OKbutton2_pan.pos_y = 160;
		instructions_pan.bmap = instructions_800_jpg;
		instructions_pan.size_x = 800;
		instructions_pan.size_y = 600;
		instructions_pan.pos_x = 0;
		instructions_pan.pos_y = 0;
		danke_pan.pos_x = 80;
		danke_pan.pos_y = 60;
		compcongmes_pan.pos_x = 80;
		compcongmes_pan.pos_y = 60;
		1highscore_pan.pos_x = 800/8;
		1highscore_pan.pos_y = 600/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 600/2;
		ingamemenu_pan.pos_x = 800/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 600/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(7,0,0);
	}
	if(resolution >= 2.5)
	{
		black_pan.size_x = 1024; 
		black_pan.size_y = 768; 
		menu_bg2_pan.bmap = menu_bg2_jpg;
		menu_bg2_pan.size_x = 1024;
		menu_bg2_pan.size_y = 768;
		menu_bg1_pan.bmap = menu_bg1_jpg;
		menu_bg1_pan.size_x = 1024;
		menu_bg1_pan.size_y = 768;
		menu_but_pan.pos_x = 312;
		menu_but_pan.pos_y = 184;
		level_but_pan.scale_x = 1;
		level_but_pan.scale_y = 1;
		options_pan.pos_x = 362;
		options_pan.pos_y = 284;
		return_pan.scale_x = 1;
		return_pan.scale_y = 1;
		return_pan.pos_y = 0;
		returntomenu_pan.pos_x = 874;
		returntomenu_pan.pos_y = 706;
		guntable_pan.scale_x = 1;
		guntable_pan.scale_y = 1;
		guntable_pan.pos_y = 500;
		guntable_mask_pan.scale_x = 1;
		guntable_mask_pan.scale_y = 1;
		guntable_mask_pan.pos_y = 498;
		ready_pan.bmap = ready_jpg;
		ready_pan.size_x = 1024;
		ready_pan.size_y = 90;
		ready_pan.pos_y = 250;
		go_pan.bmap = go_jpg;
		go_pan.size_x = 1024;
		go_pan.size_y = 90;
		go_pan.pos_y = 250;
		game_over_pan.bmap = game_over_jpg;
		game_over_pan.size_x = 1024;
		game_over_pan.size_y = 100;
		game_over_pan.pos_y = 250;
		worldclear_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		worldclear_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		levelclear_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		levelclear_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		congratulations_pan.pos_x = levelclear_pan.pos_x;
		congratulations_pan.pos_y = levelclear_pan.pos_y;
		congratulations2_pan.pos_x = levelclear_pan.pos_x;
		congratulations2_pan.pos_y = levelclear_pan.pos_y;
		OKbutton_pan.pos_x = 342;
		OKbutton_pan.pos_y = 200;
		OKbutton2_pan.pos_x = 342;
		OKbutton2_pan.pos_y = 200;
		instructions_pan.bmap = instructions_800_jpg;
		instructions_pan.size_x = 800;
		instructions_pan.size_y = 600;
		instructions_pan.pos_x = 112;
		instructions_pan.pos_y = 84;
		danke_pan.pos_x = 192;
		danke_pan.pos_y = 144;
		compcongmes_pan.pos_x = 192;
		compcongmes_pan.pos_y = 144;
		1highscore_pan.pos_x = 1024/8;
		1highscore_pan.pos_y = 768/2;
		1highscore_txt.pos_x = 1highscore_pan.pos_x - 75;
		1highscore_txt.pos_y = 768/2;
		ingamemenu_pan.pos_x = 1024/2 - bmap_width(ingamemenu_jpg)/2;
		ingamemenu_pan.pos_y = 768/2 - bmap_height(ingamemenu_jpg)/2;
		igoptions_pan.pos_x = ingamemenu_pan.pos_x;
		igoptions_pan.pos_y = ingamemenu_pan.pos_y;
		video_switch(8,0,0);
	}	
	
	temp_var=resolution;
}
}

function igquit_func
{
game_over_var = 1;
congratulations_pan.visible = off;
congratulations2_pan.visible = off;
levelclear_pan.visible = off;
ingamemenu_pan.visible = off;
igoptions_pan.visible = off;
mouse_mode = 0;
show_mouse = 0;
OKbutton_pan.visible = off;
OKbutton2_pan.visible = off;
congratulations_pan.visible = off;
congratulations2_pan.visible = off;
returntomenu_pan.visible = off;
pause = 1;
mode_blockattack = 0;
level_number = 0;
level001 = 0;
level001_loaded = 0;
level002 = 0;
level002_loaded = 0;
level003 = 0;
level003_loaded = 0;
level004 = 0;
level004_loaded = 0;
cubes_shot = 0;
cube_amount = 0;
score = 0;
old_level = 0;
gun_ent.visible = off;
score_pan.visible = off;
guntable_pan.visible = off;
guntable_mask_pan.visible = off;,
menu = 1;
pause = 0;
freeze_mode = 0;
}

function igquitas_func
{
game_over_var = 1;
congratulations_pan.visible = off;
congratulations2_pan.visible = off;
levelclear_pan.visible = off;
ingamemenu_pan.visible = off;
igoptions_pan.visible = off;
mouse_mode = 0;
show_mouse = 0;
OKbutton_pan.visible = off;
OKbutton2_pan.visible = off;
congratulations_pan.visible = off;
congratulations2_pan.visible = off;
returntomenu_pan.visible = off;
game_over_pan.visible = off;
pause = 1;
mode_blockattack = 0;
level001 = 0;
level001_loaded = 0;
level002 = 0;
level002_loaded = 0;
level003 = 0;
level003_loaded = 0;
level004 = 0;
level004_loaded = 0;
old_level = 0;
cubes_shot = 0;
cube_amount = 0;
level_number = 0;
if(score > 1hscore5 && score <= 1hscore4)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_var_write(filehandle,score);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_close(filehandle);
}
if(score > 1hscore4 && score <= 1hscore3)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}
if(score > 1hscore3 && score <= 1hscore2)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}
if(score > 1hscore2 && score <= 1hscore1)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}
if(score > 1hscore1)
{
	filehandle = file_open_write("hs1.txt");
	file_var_write(filehandle,score);
	file_var_write(filehandle,1hscore1);
	file_var_write(filehandle,1hscore2);
	file_var_write(filehandle,1hscore3);
	file_var_write(filehandle,1hscore4);
	file_str_write(filehandle,playername);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl1);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl2);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl3);
	file_str_write(filehandle,",");
	file_str_write(filehandle,1hscorepl4);
	file_close(filehandle);
}

score = 0;
gun_ent.visible = off;
score_pan.visible = off;
guntable_pan.visible = off;
guntable_mask_pan.visible = off;
menu = 1;
pause = 0;
freeze_mode = 0;
}